const ASYNC_EVENT_ID = "LaggedAPIEvent";

//CHANGE THE FOLLOWING ID VARIABLES TO MATCH THE PROPER ID VALUES YOU HAVE
const DEV_ID = "DEV_ID";
const PUBLISHER_ID = "PUBLISHER_ID"; 

function init()
{
    console.log("LaggedAPI.js: init");
    LaggedAPI.init(DEV_ID, PUBLISHER_ID);    
}

//NOTE: pause the game and mute music before calling this
function showAd()
{
    LaggedAPI.APIAds.show(function() 
    {
        var map = {};
        map["id"] = ASYNC_EVENT_ID;
        map["event_type"] = "ad_watched";        
        GMS_API.send_async_event_social(map);

        //NOTE: Unpause the game and unmute the music after receving this callback
        
        console.log("LaggedAPI.js: ad watched");    
    });
}

function saveAchievement(awardId)
{
    var apiAwards = [];
    apiAwards.push(awardId); //NOTE: you can push more than one award at a time
    var map = {};
    map["id"] = ASYNC_EVENT_ID;
    
    LaggedAPI.Achievements.save(apiAwards, function(response) 
    {
        if(response.success) 
        {
            console.log("LaggedAPI.js: achievement " + awardId + " saved");      
            map["event_type"] = "achievement_save_success";
        }
        else 
        {
            console.log("LaggedAPI.js: "+ response.errormsg);
            map["event_type"] = "achievement_save_error";
        }
    
        GMS_API.send_async_event_social(map);
    });
}

function saveHighScore(highScoreBoardId, newHighScore)
{
    var boardinfo = {};
    boardinfo.score = newHighScore;
    boardinfo.board = highScoreBoardId;

    var map = {};
    map["id"] = ASYNC_EVENT_ID;

    LaggedAPI.Scores.save(boardinfo, function(response) 
    {
        if(response.success) 
        {
            map["event_type"] = "high_score_save_success";
            console.log("LaggedAPI.js: high score saved")
        }
        else 
        {
            map["event_type"] = "high_score_save_error";
            console.log("LaggedAPI.js: " + response.errormsg);
        }

        GMS_API.send_async_event_social(map);
    });
}

function prepareRewardedAd()
{    
    LaggedAPI.GEvents.reward(canShowReward, rewardSuccess);
}

//NOTE: prepareRewardedAd() must be called successfully before this method can be used to show the ad
function showRewardedAd()
{
    showAdFunction();
}

var showAdFunction;

var canShowReward = function(success, showAdFn)
{        
    var map = {};
    map["id"] = ASYNC_EVENT_ID;

    if(success)
    {            
        map["event_type"] = "rewarded_ad_available";
        showAdFunction = showAdFn;
        console.log("LaggedAPI.js: rewarded ad available");
    }
    else
    {
        map["event_type"] = "rewarded_ad_unavailable";
        console.log("LaggedAPI.js: rewarded ad unavailable");
    }
    
    GMS_API.send_async_event_social(map);
}

var rewardSuccess = function(success)
{
    var map = {};
    map["id"] = ASYNC_EVENT_ID;

    if (success)
    {
        map["event_type"] = "rewarded_ad_watched";
        console.log("LaggedAPI.js: rewarded ad watched");
    }
    else
    {
        map["event_type"] = "rewarded_ad_not_watched";
        console.log("LaggedAPI.js: rewarded ad not watched");
    }

    GMS_API.send_async_event_social(map);
}